//RemplacerNuance_502f.js
// 12.01.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Remplacer une nuance par une autre

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// s'assurer qu'il n'y ait pas de page "Gabarit" affiche
if (app.activeWindow.activeSpread.constructor.name == "MasterSpread") {
	alert ("Ne fonctionne pas avec des pages Gabarit.", "Stop");
	exit ();
}

// mmoriser la version
var appVers = (app.version[0])*1;

// dfinir les noms des nuances fixes
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// mmoriser la langue de l'application
var curLang = (app.locale)*1;

// prparer les noms des nuances (en FR et DE)
if (curLang   == 1279477362) { // = franais
	noColor      = "[Sans]";
	regisColor   = "[Reprage]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
	}
}
else if (curLang == 1279477613) { // = allemand
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}
// le document au premier plan
var curDoc = app.documents[0];

// les nuances du document
allSwatches = curDoc.swatches;

// vrifier une slection ventuelle
var noSel  = true;
var oColor = "";
if (app.selection.length != 0) {
	var baseColors = "|Black|Paper|Registration|None|";
	try {
		var selColorStrk = app.selection[0].strokeColor.name;
		var testStrkName = "|" + selColorStrk + "|";
		if (app.selection[0].constructor.name != "GraphicLine") {
			var selColorFill = app.selection[0].fillColor.name;
			var testFillName = "|" + selColorFill + "|";
			if (baseColors.indexOf(testFillName) == -1) {
				oColor = selColorFill;
			}
		}
		if (oColor == "") {
			if (baseColors.indexOf(testStrkName) == -1) {
				oColor = selColorStrk;
			}
		}
		noSel = false;
	}
	catch (e) {
	}
}

// prparer les valeurs des cases  cocher
ck00 = ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = ck07 = ck08 = ck09 = ck10 = ck11 = 0;

// la liste des numros des pages
allPageNames = app.documents[0].pages.everyItem().name;

// appeler la fonction qui lit les rglages enregistrs
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	if (noSel == false && oColor != "") {
		oName = oColor;
	}
	else {
		var oName = prefVal[0];
		if      (oName == "Black") { oName = blackColor; }
		else if (oName == "Paper") { oName = paperColor; }
		else if (oName == "Registration") { oName = regisColor; }
		else if (oName == "None")  { oName = noColor; }
	}
	var nName = prefVal[1];
	if      (nName == "Black") { nName = blackColor; }
	else if (nName == "Paper") { nName = paperColor; }
	else if (nName == "Registration") { nName = regisColor; }
	else if (nName == "None")  { nName = noColor; }
	pNum = prefVal[2];
	var okay = rangeOfPages(pNum, true);
	if (okay == false) {
		if (noSel == false) {
			try {
				pNum = app.selection[0].parentPage.name;
			}
			catch (e) {
				try {
					pNum = app.activeWindow.activePage.name;
				}
				catch (e) {
					pNum = allPageNames[0];
				}
			}
		}
		else {
			try {
				pNum = app.activeWindow.activePage.name;
			}
			catch (e) {
				pNum = allPageNames[0];
			}
		}
	}
	var cb00 = prefVal[3];
	if (cb00 == "true") { ck00 = 1; }
	var cb01 = prefVal[4];
	if (cb01 == "true") { ck01 = 1; }
	var cb02 = prefVal[5];
	if (cb02 == "true") { ck02 = 1; }
	var cb03 = prefVal[6];
	if (cb03 == "true") { ck03 = 1; }
	var cb04 = prefVal[7];
	if (cb04 == "true") { ck04 = 1; }
	var cb05 = prefVal[8];
	if (cb05 == "true") { ck05 = 1; }
	var cb06 = prefVal[9];
	if (cb06 == "true") { ck06 = 1; }
	var cb07 = prefVal[10];
	if (cb07 == "true") { ck07 = 1; }
	var cb08 = prefVal[11];
	if (cb08 == "true") { ck08 = 1; }
	var cb09 = prefVal[12];
	if (cb09 == "true") { ck09 = 1; }
	var cb10 = prefVal[13];
	if (cb10 == "true") { ck10 = 1; }
	var cb11 = prefVal[14];
	if (cb11 == "true") { ck11 = 1; }
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	ck00 = 1;
	ck01 = 1;
	ck02 = 0;
	ck03 = 1;
	ck04 = 1;
	ck05 = 1;
	ck06 = 1;
	ck07 = 0;
	ck08 = 0;
	ck09 = 0;
	ck10 = 0;
	ck11 = 0;
	if (noSel == false && oColor != "") {
		oName = oColor;
	}
	else {
		oName = blackColor;
	}
	nName = blackColor;
	if (noSel == false) {
		try {
			pNum = app.selection[0].parentPage.name;
		}
		catch (e) {
			try {
				pNum = app.activeWindow.activePage.name;
			}
			catch (e) {
				pNum = allPageNames[0];
			}
		}
	}
	else {
		try {
			pNum = app.activeWindow.activePage.name;
		}
		catch (e) {
			pNum = allPageNames[0];
		}
	}
}

// appeler les fonctions qui prparent les listes des couleurs
var oldColor = getOldColorList(oName);
var oldCol   = oldColor[0];
var oInd     = oldColor[1];
var newColor = getNewColorList(nName);
var newCol   = newColor[0];
var nInd     = newColor[1];

// appeler la fonction qui affiche le dialogue et convertit les valeurs
var anArray = displayDialog();
var oColor  = anArray[0];
var nColor  = anArray[1];
var pNum    = anArray[2];
var ck00    = anArray[3];
var ck01    = anArray[4];
var ck02    = anArray[5];
var ck03    = anArray[6];
var ck04    = anArray[7];
var ck05    = anArray[8];
var ck06    = anArray[9];
var ck07    = anArray[10];
var ck08    = anArray[11];
var ck09    = anArray[12];
var ck10    = anArray[13];
var ck11    = anArray[14];

// comparer les nuances slectionnes
if (oColor == nColor) {
	alert ("L'ancienne et la nouvelle couleur sont identiques.", "Stop");
	exit();
}

// vrifier la saisie
allPages = rangeOfPages(pNum, false);

// arrter le rafrachissement
app.scriptPreferences.enableRedraw = false;

// une boucle  travers les pages
for (var p=0; p<allPages.length; p++) {
	// appeler la fonction qui change les couleurs
	changeColor(oColor, nColor, allPages[p]);
}

// activer le rafrachissement
app.scriptPreferences.enableRedraw = true;

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();


////////////////////////////// les fonctions  /////////////////////////////////////////////////////

// la fonction qui prpare les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/remplacernuance502.txt");
	}
	else {
		var f = new File("~/Library/Preferences/remplacernuance502.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// la fonction qui prpare la liste des "anciennes" nuances ///////////////////////////////////////
function getOldColorList(oName) {	
	// vrifier si la nuance par dfaut existe
	if (oName != noColor && oName != regisColor && oName != paperColor && oName != blackColor) {
		try {
			curDoc.swatches.itemByName(oName).name;
		}
		catch (e) {
			oName = blackColor;
		}
	}
	// lister les nuances;
	// renommer "None", "Paper", "Black" et "Registration";
	// mmoriser la position de la nuance par dfaut
	var oldColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (oName == cName) {
			oIndex = i;
		}
		oldColorList.push(cName);
	}
	return [oldColorList, oIndex];
}

// la fonction qui prpare la liste des "nouvelles" nuances ///////////////////////////////////////
function getNewColorList(nName) {	
	// vrifier si la nuance par dfaut existe
	if (nName != noColor && nName != regisColor && nName != paperColor && nName != blackColor) {
		try {
			curDoc.swatches.itemByName(nName).name;
		}
		catch (e) {
			nName = blackColor;
		}
	}
	// lister les nuances;
	// renommer "None", "Paper", "Black" et "Registration";
	// mmoriser la position de la nuance par dfaut
	var oldColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (nName == cName) {
			oIndex = i;
		}
		oldColorList.push(cName);
	}
	return [oldColorList, oIndex];
}

// prparer et afficher le dialogue ///////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth =  70;
	var fieldWidth = 250;
	var aDialog = app.dialogs.add({name:"RemplacerNuance"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Nuance applique...", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var oldColor = dropdowns.add({stringList:oldCol, selectedIndex:oInd, minWidth:225});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"...  remplacer par celle-ci", minWidth:labelWidth-10});
						staticTexts.add({staticLabel:" "});
					}
					var newColor = dropdowns.add({stringList:newCol, selectedIndex:nInd, minWidth:225});
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Range(s) de pages (ex.: 1, 2-3, 4-7):"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var pagesField = textEditboxes.add({editContents:pNum, minWidth:fieldWidth});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Traiter les objets suivants:"});
				staticTexts.add({staticLabel:" ", minWidth:10});
			}
			with (dialogRows.add()) {
				var checkbox00 = checkboxControls.add({staticLabel:"Fond", checkedState:ck00, minWidth:84});
				var checkbox01 = checkboxControls.add({staticLabel:"Contour", checkedState:ck01, minWidth:84});
				var checkbox02 = checkboxControls.add({staticLabel:"Espace", checkedState:ck02});
			}
			with (dialogRows.add()) {
				var checkbox03 = checkboxControls.add({staticLabel:"Blocs image", checkedState:ck03, minWidth:140});
				var checkbox04 = checkboxControls.add({staticLabel:"Blocs texte", checkedState:ck04});
			}
			with (dialogRows.add()) {
				var checkbox05 = checkboxControls.add({staticLabel:"Blocs graphiques", checkedState:ck05, minWidth:140});
				var checkbox06 = checkboxControls.add({staticLabel:"Blocs trait", checkedState:ck06});
			}
			with (dialogRows.add()) {
				var checkbox07 = checkboxControls.add({staticLabel:"Tableaux", checkedState:ck07, minWidth:140});
				var checkbox08 = checkboxControls.add({staticLabel:"Textes", checkedState:ck08});
			}
			with (dialogRows.add()) {
				var checkbox09 = checkboxControls.add({staticLabel:"Filets de paragraphe", checkedState:ck09, minWidth:140});
				var checkbox10 = checkboxControls.add({staticLabel:"Soulignages", checkedState:ck10});
			}
			with (dialogRows.add()) {
				var checkbox11 = checkboxControls.add({staticLabel:"Effets (ombre porte, etc.)", checkedState:ck11});
			}
		}
	}
	if(aDialog.show() == true) {
		oldIndex = oldColor.selectedIndex;
		oColor = curDoc.swatches[oldIndex].name;
		if      (oColor == blackColor) { oColor = "Black"; }
		else if (oColor == paperColor) { oColor = "Paper"; }
		else if (oColor == regisColor) { oColor = "Registration"; }
		else if (oColor == noColor)    { oColor = "None"; }
		newIndex = newColor.selectedIndex;
		nColor = curDoc.swatches[newIndex].name;
		if      (nColor == blackColor) { nColor = "Black"; }
		else if (nColor == paperColor) { nColor = "Paper"; }
		else if (nColor == regisColor) { nColor = "Registration"; }
		else if (nColor == noColor)    { nColor = "None"; }
		pNum = pagesField.editContents;
		cb00 = checkbox00.checkedState;
		cb01 = checkbox01.checkedState;
		cb02 = checkbox02.checkedState;
		cb03 = checkbox03.checkedState;
		cb04 = checkbox04.checkedState;
		cb05 = checkbox05.checkedState;
		cb06 = checkbox06.checkedState;
		cb07 = checkbox07.checkedState;
		cb08 = checkbox08.checkedState;
		cb09 = checkbox09.checkedState;
		cb10 = checkbox10.checkedState;
		cb11 = checkbox11.checkedState;
		aDialog.destroy();
		var prefsList = new Array (oColor, nColor, pNum, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		if (pNum == "") {
			alert ("Range(s) de pages: le champ de saisie est vide.", "Stop");
			exit();
		}
		return [oColor, nColor, pNum, cb00, cb01, cb02, cb03, cb04, cb05, cb06, cb07, cb08, cb09, cb10, cb11];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/remplacernuance502.txt");
	}
	else {
		var f = File("~/Library/Preferences/remplacernuance502.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// lister et vrifier les numros des pages  //////////////////////////////////////////////////////
function rangeOfPages(pageRange, pre) {
	var whatKind = 0;
	var startPagesList = new Array ();
	var stopPagesList  = new Array ();
	var pagesList      = new Array ();
	// supprimer les espaces
	var newRange = pageRange.split(" ");
	newRange = newRange.join("");
	// verifier si la saisie contient des virgules et/ou des traits-d'unions
	if (newRange.indexOf("+") != -1) {
		alert ("Des valeurs absolues ne sont pas possibles.", "Stop");
		exit();
	}
	if (newRange.indexOf("-") != -1) {
		whatKind = whatKind + 1;
	}
	if (newRange.indexOf(",") != -1) {
		whatKind = whatKind + 2;
	}
	// crer les listes selon le genre
	if (whatKind == 0) {
		pagesList.push(newRange);
	}
	else if (whatKind == 1) {
		var newRangeList = newRange.split("-");
		var startVal = newRangeList[0]*1;
		var stopVal  = (newRangeList[1]*1)+1;
		for (var i=startVal; i<stopVal; i++) {
			pagesList.push(""+i);
		}
	}
	else if (whatKind == 2) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			pagesList.push(newRangeList[i]);
		}
	}
	else if (whatKind == 3) {
		var newRangeList = newRange.split(",");
		for (var i=0; i<newRangeList.length; i++) {
			var tmpItem = newRangeList[i];
			if (tmpItem.indexOf("-") != -1) {
				var tmpItemList = tmpItem.split("-");
				var startVal = tmpItemList[0]*1;
				var stopVal  = (tmpItemList[1]*1)+1;
				for (var k=startVal; k<stopVal; k++) {
					pagesList.push(""+k);
				}
			}
			else {
				pagesList.push(newRangeList[i]);
			}
		}
	}
	
	// vrifier si les pages dsires existent
	var nNum = pagesList.length;
	for (var i=0; i<nNum; i++) {
		var okay = false;
		var actNum = pagesList[i];
		for (var k=0; k<allPageNames.length; k++) {
			if (actNum == allPageNames[k]) {
				okay = true;
				break;
			}
		}
		if (!okay) {
			if (pre) {
				return false;
			}
			else {
				alert ("La page " + actNum + " n'existe pas.", "Stop");
				exit();
			}
		}
	}
	if (pre) {
		return true;
	}
	else {
		return pagesList;
	}
}

// la fonction qui modifie l'application de la nuance /////////////////////////////////////////////
function changeColor(oColor, nColor, pNum) {
	// tous les objets de la page
	var allFrames = curDoc.pages.itemByName(pNum).allPageItems.slice(0);
	// la nuance actuelle
	var curSwatch = curDoc.swatches.itemByName(nColor);
	// une boucle  travers les objets
	for (var f=0; f<allFrames.length; f++) {
		// une boucle  un tour (est quitte quand il s'agit d'une image ou d'un groupe)
		for (var once=0; once<1; once++) {
			// le genre de l'objet
			var curType = allFrames[f].constructor.name;
			if (curType == "Group") {
				break;
			}
			// le type du contenu de l'objet
			try {
				var curCont = allFrames[f].contentType;
			}
			catch (e) {
				break;
			}
			// si "Text", vrifier si l'objet contient du texte curviligne
			if (ck08) {
				var curTxtPath = allFrames[f].textPaths[0];
				try {
					if (curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor.name == oColor) {
						curTxtPath.texts[0].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					curTxtPath.texts[0].contents;
					var curText = curTxtPath.texts[0];
					var allRanges = curText.textStyleRanges;
					// une boucle  travers les 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// la couleur du fond
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// la couleur du contour
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// le soulignement
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // soulignement / espace
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
					if (ck09) {
						var allParas = curText.paragraphs;
						// une boucle  travers les paragraphes
						for (var s=0; s<allParas.length; s++) {
							// filet de paragraphe "au-dessus" et "au-dessous"
							replaceRule(allParas[s], oColor, curSwatch);
							// espace dans filet de paragraphe "au-dessus" et "au-dessous"
							replaceRuleGap(allParas[s], oColor, curSwatch);
						}
					}
				}
				catch (e) {
				}
			}
			// les blocs texte
			if (curCont == ContentType.TEXT_TYPE) {
				// la couleur du fond
				if (ck04) {
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// la couleur du contour
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// la couleur d'espace
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
				}
				var curText = allFrames[f].texts[0];
				if (ck08) {
					if (allFrames[f].texts[0].insertionPoints[0].fillColor.name == oColor) {
						allFrames[f].texts[0].insertionPoints[0].fillColor = curSwatch;
					}
					var allRanges = curText.textStyleRanges;
					// une boucle  travers les 'text style ranges'
					for (var r=0; r<allRanges.length; r++) {
						// la couleur du fond
						if (ck00) {
							if (allRanges[r].fillColor.name == oColor) {
								allRanges[r].fillColor = curSwatch;
							}
						}
						// la couleur du contour
						if (ck01) {
							if (allRanges[r].strokeColor.name == oColor) {
								allRanges[r].strokeColor = curSwatch;
							}
						}
						// le soulignement
						if (ck10) {
							if (allRanges[r].underlineColor.name == oColor) {
								allRanges[r].underlineColor = curSwatch;
							}
							if (ck02) { // soulignement / espace
								if (allRanges[r].underlineGapColor.name == oColor) {
									allRanges[r].underlineGapColor = curSwatch;
								}
							}
						}
					}
				}
				if (ck09) {
					var allParas = curText.paragraphs;
					// une boucle  travers les paragraphes
					for (var s=0; s<allParas.length; s++) {
						// filet de paragraphe "au-dessus" et "au-dessous" 
						replaceRule(allParas[s], oColor, curSwatch);
						// espace dans filet de paragraphe "au-dessus" et "au-dessous"
						replaceRuleGap(allParas[s], oColor, curSwatch);
					}
				}
				if (ck07) {
					var allTables = curText.tables;
					for (var t=0; t<allTables.length; t++) {
						// la couleur du contour
						replaceStrokeTable(allTables[t], oColor, curSwatch);
						var allCells = allTables[t].cells;
						// cellules (contour, fond, contenu)
						for (var c=0; c<allCells.length; c++) {
							replaceCellStroke(allCells[c], oColor, curSwatch);
							replaceCellFill(allCells[c], oColor, curSwatch);
							replaceCellText(allCells[c], oColor, curSwatch);
						}
					}
				}
				// ombre porte, etc.
				if (ck11) {
					replaceDrop(allFrames[f], oColor, curSwatch);
					replaceDropText(allFrames[f], oColor, curSwatch);
				}
			}
			// non attribu
			else if (curCont == ContentType.UNASSIGNED) {
				// bloc trait
				if (curType == "GraphicLine") {
					if (ck06) {
						// la couleur de fond (invisible)  "[Sans]"
						replaceFill(allFrames[f], oColor, "None");
						// la couleur du contour
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// la couleur d'espace
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// ombre porte, etc.
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
				else {
					if (ck03) {
						// la couleur du fond
						if (ck00) {
							replaceFill(allFrames[f], oColor, curSwatch);
						}
						// la couleur du contour
						if (ck01) {
							replaceStroke(allFrames[f], oColor, curSwatch);
						}
						// la couleur d'espace
						if (ck02) {
							replaceGap(allFrames[f], oColor, curSwatch);
						}
						// ombre porte, etc.
						if (ck11) {
							replaceDrop(allFrames[f], oColor, curSwatch);
						}
					}
				}
			}
			// un bloc image
			else if (curCont == ContentType.GRAPHIC_TYPE) {
				if (ck03) {
					// la couleur du fond
					if (ck00) {
						replaceFill(allFrames[f], oColor, curSwatch);
					}
					// la couleur du contour
					if (ck01) {
						replaceStroke(allFrames[f], oColor, curSwatch);
					}
					// la couleur d'espace
					if (ck02) {
						replaceGap(allFrames[f], oColor, curSwatch);
					}
					// ombre porte, etc.
					if (ck11) {
						replaceDrop(allFrames[f], oColor, curSwatch);
					}
				}
			}
		}
	}
}

// remplacer la nuance du fond ////////////////////////////////////////////////////////////////////
function replaceFill(curFrame, oColor, curSwatch) {
	if (curFrame.fillColor.name == oColor) {
		curFrame.fillColor = curSwatch;
	}
}

// remplacer la nuance du contour /////////////////////////////////////////////////////////////////
function replaceStroke(curFrame, oColor, curSwatch) {
	if (curFrame.strokeColor.name == oColor) {
		curFrame.strokeColor = curSwatch;
	}
}

// remplacer la nuance d'espace ///////////////////////////////////////////////////////////////////
function replaceGap(curFrame, oColor, curSwatch) {
	if (curFrame.gapColor.name == oColor) {
		curFrame.gapColor = curSwatch;
	}
}

// les filets de paragraphe "au-dessus" et "au-dessous" ///////////////////////////////////////////
function replaceRule(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveColor.name == oColor) {
		curFrame.ruleAboveColor = curSwatch;
	}
	if (curFrame.ruleBelowColor.name == oColor) {
		curFrame.ruleBelowColor = curSwatch;
	}
}

// espace dans filet de paragraphe "au-dessus" et "au-dessous" ////////////////////////////////////
function replaceRuleGap(curFrame, oColor, curSwatch) {
	if (curFrame.ruleAboveGapColor.name == oColor) {
		curFrame.ruleAboveGapColor = curSwatch;
	}
	if (curFrame.ruleBelowGapColor.name == oColor) {
		curFrame.ruleBelowGapColor = curSwatch;
	}
}

// les contours d'un tableau //////////////////////////////////////////////////////////////////////
function replaceStrokeTable(curFrame, oColor, curSwatch) {
	if (curFrame.topBorderStrokeColor.name == oColor) {
		curFrame.topBorderStrokeColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeColor.name == oColor) {
		curFrame.leftBorderStrokeColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeColor.name == oColor) {
		curFrame.bottomBorderStrokeColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeColor.name == oColor) {
		curFrame.rightBorderStrokeColor = curSwatch;
	}
	if (curFrame.topBorderStrokeGapColor.name == oColor) {
		curFrame.topBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.leftBorderStrokeGapColor.name == oColor) {
		curFrame.leftBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.bottomBorderStrokeGapColor.name == oColor) {
		curFrame.bottomBorderStrokeGapColor = curSwatch;
	}
	if (curFrame.rightBorderStrokeGapColor.name == oColor) {
		curFrame.rightBorderStrokeGapColor = curSwatch;
	}
}

// les contours des cellules d'un tableau /////////////////////////////////////////////////////////
function replaceCellStroke(curCell, oColor, curSwatch) {
	if (curCell.topEdgeStrokeColor.name == oColor) {
		curCell.topEdgeStrokeColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeColor.name == oColor) {
		curCell.leftEdgeStrokeColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeColor.name == oColor) {
		curCell.bottomEdgeStrokeColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeColor.name == oColor) {
		curCell.rightEdgeStrokeColor = curSwatch;
	}
	if (curCell.topEdgeStrokeGapColor.name == oColor) {
		curCell.topEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.leftEdgeStrokeGapColor.name == oColor) {
		curCell.leftEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.bottomEdgeStrokeGapColor.name == oColor) {
		curCell.bottomEdgeStrokeGapColor = curSwatch;
	}
	if (curCell.rightEdgeStrokeGapColor.name == oColor) {
		curCell.rightEdgeStrokeGapColor = curSwatch;
	}
}

// les fonds des cellules d'un tableau ////////////////////////////////////////////////////////////
function replaceCellFill(curCell, oColor, curSwatch) {
	if (curCell.fillColor.name == oColor) {
		curCell.fillColor = curSwatch;
	}
}

// les contenus des cellules d'un tableau  ////////////////////////////////////////////////////////
function replaceCellText(curCell, oColor, curSwatch) {
	var curText = curCell.texts[0];
	var allRanges = curText.textStyleRanges;
	// une boucle  travers les 'text style ranges'
	for (var r=0; r<allRanges.length; r++) {
		// la couleur du fond
		if (allRanges[r].fillColor.name == oColor) {
			allRanges[r].fillColor = curSwatch;
		}
		// la couleur du contour
		if (allRanges[r].strokeColor.name == oColor) {
			allRanges[r].strokeColor = curSwatch;
		}
	}
}

// effets (ombre porte, etc.) //////////////////////////////////////////////////////////////////
function replaceDrop(curFrame, oColor, curSwatch) {
	// objet / ombre porte
	if (curFrame.transparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// fond / ombre porte
	if (curFrame.fillTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// contour / ombre porte
	if (curFrame.strokeTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	// objet / ombre interne
	if (curFrame.transparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// fond / ombre interne
	if (curFrame.fillTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// contour / ombre interne
	if (curFrame.strokeTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	// objet / lueur externe
	if (curFrame.transparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// fond / lueur externe
	if (curFrame.fillTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// contour / lueur externe
	if (curFrame.strokeTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	// objet / lueur interne
	if (curFrame.transparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// fond / lueur interne
	if (curFrame.fillTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// contour / lueur interne
	if (curFrame.strokeTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	// objet / biseau et estampage / ton clair
	if (curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// objet / biseau et estampage / ton fonc
	if (curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.transparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// fond / biseau et estampage / ton clair
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// fond / biseau et estampage / ton fonc
	if (curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.fillTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// contour / biseau et estampage / ton clair
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	// contour / biseau et estampage / ton fonc
	if (curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.strokeTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	// objet / satin
	if (curFrame.transparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.transparencySettings.satinSettings.effectColor = curSwatch;
	}
	// fond / satin
	if (curFrame.fillTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.fillTransparencySettings.satinSettings.effectColor = curSwatch;
	}
	// contour / satin
	if (curFrame.strokeTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.strokeTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}

// effets texte (ombre porte, etc.) //////////////////////////////////////////////////////////////////
function replaceDropText(curFrame, oColor, curSwatch) {
	if (curFrame.contentTransparencySettings.dropShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.dropShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerShadowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerShadowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.outerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.outerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.innerGlowSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.innerGlowSettings.effectColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.highlightColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor.name == oColor) {
		curFrame.contentTransparencySettings.bevelAndEmbossSettings.shadowColor = curSwatch;
	}
	if (curFrame.contentTransparencySettings.satinSettings.effectColor.name == oColor) {
		curFrame.contentTransparencySettings.satinSettings.effectColor = curSwatch;
	}
}